"""
bpp.py:
Using SCOP2 for solving a bin packing problem
Copyright (c) by Mikio KUBO, 2013
"""
from scop import *
bpp=Model()

Items=[6,5,4,3,1,2]
B=7
num_bins=3
n=len(Items)

x={}
for i in range(n):
     x[i] = bpp.addVariable("x_{0}".format(i),range(num_bins))
Bin={}
for j in range(num_bins):
     Bin[j]=Linear("Bin_{0}".format(j),weight=1,rhs=B,direction="<=")
     for i in range(n):
          Bin[j].addTerms(Items[i],x[i],j)
     bpp.addConstraint(Bin[j])

sol,violated=bpp.optimize()

print (bpp)

print ("solution=")
for i in sol:
    print (i,sol[i])

print ("violated constraints=",violated)
